package ru.dbotthepony.kommons.util

fun interface DelegateGetter<V> {
	operator fun invoke(field: Delegate<V>): V

	private object PASSTHROUGH : DelegateGetter<Any?> {
		override fun invoke(field: Delegate<Any?>): Any? {
			return field.get()
		}
	}

	companion object {
		fun <V> passthrough(): DelegateGetter<V> {
			return PASSTHROUGH as DelegateGetter<V>
		}
	}
}
